<?php
/**
 * Projects Section
 *
 * @package Construktly
 */

$wp_customize->add_section(
	'construktly_projects_section',
	array(
		'panel' => 'construktly_front_page_options',
		'title' => esc_html__( 'Projects Section', 'construktly' ),
	)
);

// Projects Section - Enable Section.
$wp_customize->add_setting(
	'construktly_enable_projects_section',
	array(
		'default'           => false,
		'sanitize_callback' => 'construktly_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Construktly_Toggle_Switch_Custom_Control(
		$wp_customize,
		'construktly_enable_projects_section',
		array(
			'label'    => esc_html__( 'Enable Projects Section', 'construktly' ),
			'section'  => 'construktly_projects_section',
			'settings' => 'construktly_enable_projects_section',
		)
	)
);

if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'construktly_enable_projects_section',
		array(
			'selector' => '#construktly_projects_section .section-link',
			'settings' => 'construktly_enable_projects_section',
		)
	);
}

// Projects Section - Section Title.
$wp_customize->add_setting(
	'construktly_projects_title',
	array(
		'default'           => __( 'Latest Projects', 'construktly' ),
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'construktly_projects_title',
	array(
		'label'           => esc_html__( 'Section Title', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_title',
		'type'            => 'text',
		'active_callback' => 'construktly_is_projects_section_enabled',
	)
);

// Projects Section - Section Text.
$wp_customize->add_setting(
	'construktly_projects_text',
	array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'construktly_projects_text',
	array(
		'label'           => esc_html__( 'Section Text', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_text',
		'type'            => 'text',
		'active_callback' => 'construktly_is_projects_section_enabled',
	)
);

// Projects Section - Number of Posts.
$wp_customize->add_setting(
	'construktly_projects_count',
	array(
		'default'           => 3,
		'sanitize_callback' => 'construktly_sanitize_number_range',
	)
);

$wp_customize->add_control(
	'construktly_projects_count',
	array(
		'label'           => esc_html__( 'Number of Posts to Show', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_count',
		'type'            => 'number',
		'input_attrs'     => array(
			'min' => 1,
			'max' => 12,
		),
		'active_callback' => 'construktly_is_projects_section_enabled',
	)
);

// Projects Section - Content Type.
$wp_customize->add_setting(
	'construktly_projects_content_type',
	array(
		'default'           => 'page',
		'sanitize_callback' => 'construktly_sanitize_select',
	)
);

$wp_customize->add_control(
	'construktly_projects_content_type',
	array(
		'label'           => esc_html__( 'Select Content Type', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_content_type',
		'type'            => 'select',
		'active_callback' => 'construktly_is_projects_section_enabled',
		'choices'         => array(
			'page' => esc_html__( 'Page', 'construktly' ),
			'post' => esc_html__( 'Post', 'construktly' ),
		),
	)
);

// List out selected number of fields.
$projects_count = get_theme_mod( 'construktly_projects_count', 3 );

for ( $i = 1; $i <= $projects_count; $i++ ) {
	// Projects Section - Select Post.
	$wp_customize->add_setting(
		'construktly_projects_content_post_' . $i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'construktly_projects_content_post_' . $i,
		array(
			/* translators: %d: count. */
			'label'           => sprintf( esc_html__( 'Select Post %d', 'construktly' ), $i ),
			'section'         => 'construktly_projects_section',
			'settings'        => 'construktly_projects_content_post_' . $i,
			'active_callback' => 'construktly_is_projects_section_and_content_type_post_enabled',
			'type'            => 'select',
			'choices'         => construktly_get_post_choices(),
		)
	);

	// Projects Section - Select Page.
	$wp_customize->add_setting(
		'construktly_projects_content_page_' . $i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'construktly_projects_content_page_' . $i,
		array(
			/* translators: %d: count. */
			'label'           => sprintf( esc_html__( 'Select Page %d', 'construktly' ), $i ),
			'section'         => 'construktly_projects_section',
			'settings'        => 'construktly_projects_content_page_' . $i,
			'active_callback' => 'construktly_is_projects_section_and_content_type_page_enabled',
			'type'            => 'select',
			'choices'         => construktly_get_page_choices(),
		)
	);

}

// Projects Section - Button Label.
$wp_customize->add_setting(
	'construktly_projects_button_label',
	array(
		'default'           => __( 'View All', 'construktly' ),
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'construktly_projects_button_label',
	array(
		'label'           => esc_html__( 'Button Label', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_button_label',
		'type'            => 'text',
		'active_callback' => 'construktly_is_projects_section_enabled',
	)
);

// Banner Section - Button Link.
$wp_customize->add_setting(
	'construktly_projects_button_link',
	array(
		'sanitize_callback' => 'esc_url_raw',
	)
);

$wp_customize->add_control(
	'construktly_projects_button_link',
	array(
		'label'           => esc_html__( 'Button Link ', 'construktly' ),
		'section'         => 'construktly_projects_section',
		'settings'        => 'construktly_projects_button_link',
		'type'            => 'url',
		'active_callback' => 'construktly_is_projects_section_enabled',
	)
);
